// PipelineDemo2.java
import java.io.*;

class PipelineDemo2 {
  public static void main(String[] args) {
    if (args.length < 1) {
      System.err.println("No args.");
      System.exit(1);
    }
    String filename = args[0];

    // input/output devices
    FileIn fileIn = new FileIn(filename);
    FileOut fileOut = new FileOut("word.out.txt");
    StdOut stdOut = new StdOut();

    // pipes
    Pipe pipe1 = new Pipe();
    Pipe pipe2 = new Pipe();

    // filters
    Filter word = new Word(fileIn, pipe1);
    Filter2 dup = new Dup(pipe1, pipe2, fileOut);
    Filter tolower = new Tolower(pipe2, stdOut);
    
    // start pipeline
    word.start();
    dup.start();
    tolower.start();
  }
}
